#ifndef _HEADER_H
#define _HEADER_H

#include "am.h"

typedef struct Token {
	// Set by the original sender.
	tag_t		 tag;			// The tag to use for this request/reply.
	int			 source;		// The source address.
	cConnection *connection;	// The connection on which this packet was received (and to be used for reply).
	cEndpoint	*endp;			// A pointer to the endpoint that is handling this AM.
} Token;

typedef struct HiddenData {
	cPacket		*packetPtr;
	cConnection	*connPtr;
} HiddenData;

typedef struct Header {
	unsigned int	 sequenceNum;	// The sequence number for this packet.
	unsigned int	 cumulativeAck;	// The cumulative ack for the sender's receive side.
	unsigned __int16 opcode;		// The opcode for this message: ex. REQUEST | REPLY | ACK
	unsigned __int16 status;		// The status for an undeliverable message.
	unsigned __int16 srcEndpoint;	// The source endpoint.
	unsigned __int16 destEndpoint;	// Unique endpoint in the bundle to send this to.
	unsigned __int16 handlerType;	// Request4, etc.
	unsigned __int16 handlerNum;	// The index into the handler's table.
	int				 args[8];		// Integer arguments for handler.
	int				 nSize;			// The size of the buffer (if there is one).
	int				 destOffset;	// Used in XFER operations.
	tag_t			 tag;			// The tag to use for matching.
	HiddenData		 hidden;		// Data that is not sent over the wire but hidden in the desc.
} Header;

#endif