#ifndef __C_AMLAYER_H
#define __C_AMLAYER_H
/*
 * cAMLayer.h
 * 
 * Class def for AM layer class.
 *
 */
#include "am.h"
#include "stdam.h"
#include "cHashTable.h"

class cBundle;

//cAMLayer class
class cAMLayer
{

 protected:

 public:
		
	//Constructor(s)
	cAMLayer();	

	//Destructor
	~cAMLayer();

	//Public Functions
	bool		 Initialize(char *deviceName);
	cBundle		*AllocateBundle();
	int			 FreeBundle(cBundle *bundle);

	// Accessors
	cNic*	GetNic();
	cPtag*	GetPtag()	{ return mPtag; }
	char* GetNodeName();
	int	  GetNodeNameLen();
	int	  GetUnique();

 private:

	//Member Vars
	cNic		 *mNic;				// Pointer to the Nic.
	cPtag		 *mPtag;			// Pointer to the global ptag!
	cBundle		**mBundleArray;		// Array of bundles in use.
	char		 *mLocalName;		// String containing the local node name.
	int			  mNameLen;			// The length of the lcoal node name.
	int			  mUnique;			// Unique number (process id for now?)
};

#endif
