#ifndef __C_CRITICALSECTION_H
#define __C_CRITICALSECTION_H
/*
 * cCriticalSection.h
 * 
 * Header for cCriticalSection guard.
 *
 */

#include <windows.h>
#include <winbase.h>

class cCriticalSection
{

 protected:

 public:
		
	// Constructor(s)
	 cCriticalSection() 
	 { 
		InitializeCriticalSection(&mCS);
	 }

	// Destructor
	 ~cCriticalSection() 
	 { 
		DeleteCriticalSection(&mCS);
	 }

	// Lock
	void	Enter()
	{
		EnterCriticalSection(&mCS);
	}

	// Unlock
	void	Leave()
	{
		LeaveCriticalSection(&mCS);
	}

 private:
	CRITICAL_SECTION	mCS;
};

#endif