#ifndef __CHASHTABLE_H__
#define __CHASHTABLE_H__

#include "Node.h"
#include "cCriticalSection.h"

// Hahs exception class.
class cHashException { 

 public: 
	cHashException(char *buf)
	{
		strncpy(mString, buf, 127);
		mString[127] = '\0';
	}
	~cHashException() { ; }

	char *ToString()
	{
		return mString;
	}
 private:
	char	mString[128];
};

//cHashTable class.
class cHashTable
{

 protected:

 public:
		
	// Constructor(s)
	cHashTable(int size);	

	// Destructor
	~cHashTable();

	// Public Functions
	Node*	Insert(void *key, void *data);
	Node*	Find(void *key, void **data);
	bool	Delete(Node *node);
	bool	Delete(void *key);
	void	Lock()		{ mCS.Enter(); }
	void	Unlock()	{ mCS.Leave(); }

	// Mutex
	cCriticalSection	mCS;

 private:
	 void	_PushFreeList(Node *node);
	 Node*	_PopFreeList();
	 int	_Hash(void *key);
	 void	_ResetNode(Node *node);

	//Member Vars
	Node	 *mNodeBlock;
	Node	 *mFreeList;
	Node	**mTable;
	Node	 *mSentinelArray;
	int		  mTableSize;
};

#endif
