#ifndef __C_PACKET_H
#define __C_PACKET_H
/*
 * cPacket.h
 * 
 * Class def for AM packet class.
 *
 */
#include "stdam.h"
#include "Header.h"

#include "vi/stdvi.h"

//cPacket class
class cPacket
{

 protected:

 public:
		
	// Constructor(s)
	cPacket(int dataSize, cNic *nic, cPtag *ptag);

	// Destructor
	~cPacket();

	// Accessor functions.
	Header*	GetHeader() { return mHeader; }
	void*	GetData()	{ return mData; }
	void	SetData(void *buf, int length);
	void	Reset();
	void	SetLength(int length)
	{
		if(length == 0)
		{
			mDescPtr->CS.SegCount	= 1;
		}
		mDescPtr->CS.Length	= (sizeof(Header)-sizeof(HiddenData)) + length;		
	}
	int		GetLength();

	VIP_DESCRIPTOR*	GetDescPtr()			{ return mDescPtr;			}
	VIP_MEM_HANDLE  GetDescMemHandle()		{ return mDescMemHandle;	}

	_en_t	 mDestAddress;

 private:
	VIP_NIC_HANDLE	 mNic;
	VIP_MEM_HANDLE	 mHeaderMemHandle;
	VIP_MEM_HANDLE	 mDataMemHandle;
	VIP_DESCRIPTOR	*mDescPtr;
	VIP_MEM_HANDLE	 mDescMemHandle;
	void	*mDescAllocPtr;
	Header  *mHeader;
	void	*mData;
	int		 mDataSize;
};

#endif