/*
 * cCQ.cpp
 * 
 * Class for VI completion queue.
 *
 * Authors:  Vicky & Ted
 * Last Mod: 13 March 1999 by ted
 */

#include "cCQ.h"

//Constructor(s)
cCQ::cCQ(VIP_ULONG count, VIP_NIC_HANDLE nic)
{
	VIP_RETURN rc;

	rc = VipCreateCQ(nic, count, &mCQHandle);
	if (rc != VIP_SUCCESS)
	{
		throw VIException("Unable to create completion queue.");
	}
}

//Accessor(s)
int	cCQ::GetEntryCount()
{
	return mEntryCount;
}

VIP_CQ_HANDLE	cCQ::GetHandle()
{
	return mCQHandle;
}

//Function(s)

/* Resize the CQ */
VIP_RETURN	cCQ::Resize(VIP_ULONG newSize)
{
	VIP_RETURN	rc;
	rc = VipResizeCQ(mCQHandle, newSize);
	if (rc != VIP_SUCCESS)
	{
		cVIError::PrintError("Unable to resize cq.", __LINE__, __FILE__, rc);
	}
	else
	{
		mEntryCount = newSize;
	}
	return rc;
}

/* Wait on the CQ */
//inline VIP_RETURN	cCQ::Wait(VIP_ULONG timeout, VIP_VI_HANDLE *ViHandle, VIP_BOOLEAN *RecvQueue)
//{
//	return VipCQWait(mCQHandle, timeout, ViHandle, RecvQueue);
//}

/* CQ Done */
//VIP_RETURN	cCQ::Done(VIP_VI_HANDLE *ViHandle, VIP_BOOLEAN *RecvQueue)
//{
//	return VipCQDone(mCQHandle, ViHandle, RecvQueue);
//}

//Destructor
cCQ::~cCQ()
{
	VIP_RETURN	rc;
	
	rc = VipDestroyCQ(mCQHandle);
	if (rc != VIP_SUCCESS)
	{
		cVIError::PrintError("Unable to destroy completion queue.", __LINE__, __FILE__, rc);
	}
}

