#ifndef __C_CQ_H
#define __C_CQ_H
/*
 * cCQ.h
 * 
 * Class def for VI completion queue class. 
 *
 * Authors:  Vicky & Ted
 * Last Mod: 13 March 1999 by ted
 */
#include "stdvint.h"

//cCQ class
class cCQ
{

	private:

		//Member Vars
		VIP_CQ_HANDLE			 mCQHandle;
		int						 mEntryCount;

	public:
		
		//Constructor(s)
		cCQ(VIP_ULONG count, VIP_NIC_HANDLE nic);	

		//Accessor(s)
		int	GetEntryCount();
		VIP_CQ_HANDLE	GetHandle();

		/* Resize the CQ */
		VIP_RETURN	Resize(VIP_ULONG newSize);

		/* Wait on the CQ */
		VIP_RETURN	Wait(VIP_ULONG timeout, VIP_VI_HANDLE *ViHandle, VIP_BOOLEAN *RecvQueue)
		{
			return VipCQWait(mCQHandle, timeout, ViHandle, RecvQueue);
		}

		/* See if done. */
		VIP_RETURN	Done(VIP_VI_HANDLE *ViHandle, VIP_BOOLEAN *RecvQueue)
		{
			return VipCQDone(mCQHandle, ViHandle, RecvQueue);
		}

		//Destructor
		~cCQ();

};

#endif
