/*
 * cDSeg.cpp
 * 
 * Class def for Data Segment data segment. 
 *
 * Authors:  Vicky & Ted
 * Last Mod: 4 March 1999 by ted
 */
#include "cDSeg.h"
#include <malloc.h>

//cDSeg class
cDSeg::cDSeg(VIP_ULONG length, VIP_MEM_ATTRIBUTES *newAttrib, VIP_NIC_HANDLE nic)
{
	VIP_RETURN rc;

	// get memory
	mDataPtr = NULL;
	mDataPtr = calloc(1, length);
	if(!mDataPtr)
	{
		throw VIException("Couldn't allocate data in DSeg constructor.");
	}
	
	// register memory	
	rc = VipRegisterMem(nic, mDataPtr, length, newAttrib, &mMemHandle);
	if (rc != VIP_SUCCESS)
	{
		throw VIException("Couldn't register memory in DSeg constructor.");
	}

	// initialize the rest of the member variables
	mMaxSize = length;
	mSize    = length;
	mNicHandle = nic;
}

cDSeg::cDSeg(VIP_ULONG length, void *buffer, VIP_MEM_ATTRIBUTES *newAttrib, VIP_NIC_HANDLE nic)
{
	VIP_RETURN rc;

	// get memory
	mDataPtr = buffer;

	// register memory	
	rc = VipRegisterMem(nic, mDataPtr, length, newAttrib, &mMemHandle);
	if (rc != VIP_SUCCESS)
	{
		throw VIException("Couldn't register memory in DSeg constructor.");
	}

	// initialize the rest of the member variables
	mMaxSize = length;
	mSize    = length;
	mNicHandle = nic;
}

cDSeg::~cDSeg()
{
	VIP_RETURN rc;

	rc = VipDeregisterMem(mNicHandle, mDataPtr, mMemHandle);
	if(rc != VIP_SUCCESS)
	{
		cVIError::PrintError("Couldn't deregister memory in DSeg destructor.", __LINE__, __FILE__, rc);
	}

	free(mDataPtr);
}