#ifndef __C_DSEG_H
#define __C_DSEG_H
/*
 * cDSeg.h
 * 
 * Class def for VI data segment. 
 *
 * Authors:  Vicky & Ted
 * Last Mod: 4 March 1999 by ted
 */
#include "stdvint.h"

//cDSeg class
class cDSeg
{
	public:
		
		//Constructor(s)
		cDSeg(VIP_ULONG length, VIP_MEM_ATTRIBUTES *newAttrib, VIP_NIC_HANDLE nic);
		cDSeg(VIP_ULONG length, void *buffer, VIP_MEM_ATTRIBUTES *newAttrib, VIP_NIC_HANDLE nic);

		//Accessor Functions
		VIP_ULONG		 GetSize() { return mSize; }
		VIP_BOOLEAN      SetSize(VIP_ULONG newSize) { mSize = newSize; return VIP_TRUE; }
		VIP_PVOID		 GetData() { return mDataPtr; }
		VIP_MEM_HANDLE	 GetMemHandle() { return mMemHandle; }

		//Destructor
		~cDSeg();

	private:

		//Member Vars
		VIP_PVOID				 mDataPtr;
		VIP_ULONG				 mMaxSize;
		VIP_ULONG				 mSize;
		VIP_MEM_HANDLE			 mMemHandle;
		VIP_NIC_HANDLE			 mNicHandle;

	protected:

};

#endif
