#ifndef __C_DESC_H
#define __C_DESC_H
/*
 * cDesc.h
 * 
 * Class def for VI descriptor class. 
 *
 * Authors:  Vicky & Ted
 * Last Mod: 4 March 1999 by ted
 */
#include "stdvint.h"

class cPtag;
class cDSeg;

//cDesc class
class cDesc
{

	private:

		//Member Vars
		VIP_PVOID				 mAllocPtr;
		VIP_DESCRIPTOR			*mDescPtr;
		VIP_MEM_HANDLE			 mMemHandle;
		VIP_NIC_HANDLE			 mNicHandle;
		int						 mNumSegments;

	protected:

	public:
		
		//Constructor(s)
		cDesc(int numSegments, VIP_MEM_ATTRIBUTES *attrib, VIP_NIC_HANDLE nic);	

		//Accessor Functions

		/* Get Internal Descriptor Pointer */
		VIP_DESCRIPTOR *GetDescPtr() { return mDescPtr; }

		/* Get Desc Mem Handle */
		VIP_MEM_HANDLE	GetMemHandle() { return mMemHandle; }

		/* Status */
		VIP_UINT32 GetStatus() { return mDescPtr->CS.Status; }

		/* Control */
		void SetControl(VIP_UINT16 control) { mDescPtr->CS.Control = control; } 

		/* Length */
		void SetLength(VIP_UINT32 length) {	mDescPtr->CS.Length = length; }
		VIP_UINT32 GetLength() { return mDescPtr->CS.Length; }

		/* SegCount */
		void SetSegCount(VIP_UINT16 count) { mDescPtr->CS.SegCount = count;	}
		VIP_UINT16  GetSegCount()				  { return mDescPtr->CS.SegCount;	}
		int		    GetMaxSegCount()			  { return mNumSegments;			}

		/* Immediate Data */
		void SetImmediateData(VIP_UINT32 value) { mDescPtr->CS.ImmediateData = value; }
		VIP_UINT32 GetImmediateData() { return mDescPtr->CS.ImmediateData; }

		/* Data Segments */
		// DSeg GetDSeg(int number, DSeg *outSeg); // will implement if we need to
		VIP_BOOLEAN SetDSeg(int number, cDSeg *seg);		
		VIP_BOOLEAN SetASeg(VIP_ADDRESS_SEGMENT *addr);

		//Destructor
		~cDesc();

		//Static functions.
		static VIP_PVOID GetData(VIP_DESCRIPTOR *desc, int segNumber)
		{
			return desc->DS[segNumber].Local.Data.Address;
		}

};

#endif
