/*
 * cPtag.cpp
 * 
 * Class implementation for VI protection tag.
 *
 * Authors:  Vicky & Ted
 * Last Mod: 27 Feb 1999
 */
#include "cPtag.h"

//Constructor(s)
cPtag::cPtag(VIP_NIC_HANDLE theNic)
{
	VIP_RETURN	rc;

	mNic = theNic;
	rc = VipCreatePtag(mNic, &mPtag);
	if (rc != VIP_SUCCESS)
	{
		throw VIException("Unable to create ptag.");
	}
}

//Accessor Functions
VIP_PROTECTION_HANDLE cPtag::GetPtag()
{
	return mPtag;
}

//Destructor
cPtag::~cPtag()
{
	VIP_RETURN 	rc;
	rc = VipDestroyPtag(mNic, mPtag);
	if (rc != VIP_SUCCESS)
	{
		cVIError::PrintError("Unable to destroy ptag.", __LINE__, __FILE__, rc);
	}
}


