#ifndef __C_VI_H
#define __C_VI_H
/*
 * cVI.h
 * 
 * Class def for VI objects.
 *
 * Authors:  Vicky & Ted
 * Last Mod: 4 March 1999 by ted
 */
#include "stdvint.h"

#include "cDesc.h"
class cCQ;
class cVIAddr;

//cVI class
class cVI
{

	public:
		
		//Constructor(s)
		cVI(VIP_NIC_HANDLE nic, VIP_VI_ATTRIBUTES *attribs);
		cVI(VIP_NIC_HANDLE nic, VIP_VI_ATTRIBUTES *attribs, cCQ *SendCQ, cCQ *RecvCQ);

		//Accessor Functions
		const VIP_VI_ATTRIBUTES* GetAttrib();
		VIP_VI_STATE			 GetState();
		VIP_BOOLEAN				 IsRecvQEmpty();
		VIP_BOOLEAN				 IsSendQEmpty();
		VIP_VI_HANDLE			 GetHandle() { return mVI; }

		//Useful Functions
		VIP_RETURN	PostSend(cDesc *desc) { return VipPostSend(mVI, desc->GetDescPtr(), desc->GetMemHandle()); }
		VIP_RETURN	PostSend(VIP_DESCRIPTOR *descPtr, VIP_MEM_HANDLE descMemHandle) { return VipPostSend(mVI, descPtr, descMemHandle); }
		VIP_RETURN	SendDone(cDesc *desc);
		VIP_RETURN	SendDone(VIP_DESCRIPTOR **DescPtr);
		VIP_RETURN	SendWait(cDesc *desc, VIP_ULONG timeout);
		VIP_RETURN	PostRecv(cDesc *desc) { return VipPostRecv(mVI, desc->GetDescPtr(), desc->GetMemHandle()); }
		VIP_RETURN	PostRecv(VIP_DESCRIPTOR *descPtr, VIP_MEM_HANDLE descMemHandle) { return VipPostRecv(mVI, descPtr, descMemHandle); }
		VIP_RETURN  RecvDone(cDesc *desc);
		VIP_RETURN	RecvDone(VIP_DESCRIPTOR **DescPtr);
		VIP_RETURN  RecvWait(cDesc *desc, VIP_ULONG timeout);

		static VIP_RETURN	SendDone(VIP_VI_HANDLE viHandle, VIP_DESCRIPTOR **DescPtr)
		{
			return VipSendDone(viHandle, DescPtr);
		}
		static VIP_RETURN	RecvDone(VIP_VI_HANDLE viHandle, VIP_DESCRIPTOR **DescPtr)
		{
			return VipRecvDone(viHandle, DescPtr);
		}

		VIP_RETURN	ConnectRequest(cVIAddr *localAddr, cVIAddr *remoteAddr, VIP_ULONG timeout);
		VIP_RETURN	ConnectWait(cVIAddr *localAddr, cVIAddr *remoteAddr, VIP_ULONG timeout);
		VIP_RETURN	ConnectAccept();
		VIP_RETURN  ConnectReject();
		VIP_RETURN	Disconnect();
		void		Flush();
		
		//Destructor
		~cVI();

	private:

		//Member Vars
		VIP_VI_HANDLE			mVI;
		VIP_NIC_HANDLE			mNic;
		VIP_VI_ATTRIBUTES		mAttribs;
		VIP_VI_STATE			mState;
		VIP_CONN_HANDLE		    mConnHandle;
		VIP_VI_ATTRIBUTES		mRemoteAttribs;
		VIP_BOOLEAN				mSendQEmpty;
		VIP_BOOLEAN				mRecvQEmpty;

		//Private Functions
		VIP_RETURN				QueryVI();

	protected:

};

#endif