#ifndef __C_VIADDR_H
#define __C_VIADDR_H
/*
 * cVIAddr.h
 * 
 * Class def for VI addresses. 
 *
 * Authors:  Vicky & Ted
 * Last Mod: 27 Feb 1999
 */
#include "stdvint.h"

#include <windows.h>

//cVIAddr class
class cVIAddr
{

	public:
		
		//Constructor(s)
		cVIAddr(VIP_NIC_HANDLE nicHandle, int nicAddressLen, int nicMaxDiscLen);	
		cVIAddr(const cVIAddr &original);	//Copy constructor

		//Useful functions
		VIP_BOOLEAN				GetHostByName(VIP_CHAR *name);
		VIP_BOOLEAN				GetHostByAddr(VIP_CHAR *outName, VIP_ULONG *outNameLen);
		VIP_BOOLEAN				GetLocalAddress();
		cVIAddr*				Copy();
		static VIP_BOOLEAN		GetLocalNodeName(char *name, unsigned long *length);
		
		//Static Function
		static VIP_BOOLEAN		GetHostByAddr(cVIAddr *addr, VIP_CHAR *outName, VIP_ULONG *outNameLen);

		//Accessor Functions
		VIP_NET_ADDRESS		  *GetAddress();
		VIP_BOOLEAN			   isValid();
		VIP_BOOLEAN			   setValid(VIP_BOOLEAN valid);
		VIP_BOOLEAN			   SetDiscriminator(const char *disc, int length);
		VIP_BOOLEAN			   GetDiscriminator(char *disc, int *length);

		//Destructor
		~cVIAddr();

	private:

		//Member Vars
		VIP_NIC_HANDLE		 mNic;
		VIP_BOOLEAN			 mIsValid;
		VIP_NET_ADDRESS		*mAddr;
		int					 mMaxDiscLen;

	protected:

};

#endif